* Fractalus water
* for Load Error Party

* const
screen_mx equ 64
screen_my equ 56
screen_width equ 80
pm_multicolor equ 0
lines equ 60

* ZPs
rega	equ $00
regx	equ $01
regy	equ $02

mask	equ $03

lx0	equ $04
ly0	equ $05
lx1	equ $06
ly1	equ $07

vram_offset equ $1c
edge_displacement equ $1d

zp equ $1e ;$0b

sx1 equ $20
sy1 equ sx1+16
st1 equ sy1+16
sx2 equ st1+16
sy2 equ sx2+16
st2 equ sy2+16
z equ st2+16
frame equ z+1
x1 equ frame+1
x2 equ x1+1
x3 equ x2+1
y1 equ x3+1
y2 equ y1+1
y3 equ y2+1
z1 equ y3+1
z2 equ z1+1
z3 equ z2+1
tmp3 equ z3+1
todo equ tmp3+1
color equ todo+1
dx equ color+1
dy equ dx+1
camx equ dy+1
camy equ camx+1
camz equ camy+1
camycounter equ camz+1
sinangle equ camycounter+1
cosangle equ sinangle+1
roty	equ cosangle+1
xx1 equ roty+1
xx2 equ xx1+1
xx3 equ xx2+1
zz1 equ xx3+1
zz2 equ zz1+1
zz3 equ zz2+1
sinx equ zz3+1
sinz equ sinx+1
cosx equ sinz+1
cosz equ cosx+1
bufferflag equ cosz+1
sprite_yposlo equ bufferflag+1
sprite_ypos equ sprite_yposlo+1
sprite_xposlo equ sprite_ypos+1
sprite_xpos equ sprite_xposlo+1
calcflag equ sprite_xpos+1

t1	equ $f8 ;$f9
t2	equ $fa ;$fb
product equ $fc ;$fd,$fe,$ff

bitmask	equ $c000
div4tab	equ $c100
square1_lo equ $c200
square1_hi equ square1_lo+512
square2_lo equ square1_hi+512
square2_hi equ square2_lo+512

sq1l equ $c200
sq1h equ $c400
sq2l equ $c600
sq2h equ $c800

heights equ $ca00
ybuffer equ $cb00
nodeheight equ $cc00

;gridxtab equ $cd00

font2	equ $d800

vram	equ $e010

	.macro m_align
	.align :1,$00
	.endm

	opt f-
	icl "rmtplayer128_zp.asm"

		opt f+
		org $2000
		jmp start

		org $2800
start		jmp init
dlist1
		.byte $f0
:2		.byte $4e,<leer,>leer
clms1		.byte $d4,<cloudline,>cloudline
clms2		.byte $54,<(cloudline+64),>(cloudline+64)
		.byte $80
.rept 100
		.byte $5e
		.word logo+#*40
.endr
		.byte $f0
		.rept lines
		.byte $4e,<[vram+#*screen_width],>[vram+#*screen_width]
		.endr
		.byte $80
:2		.byte $4e,<leer,>leer


		.byte $70
		.byte $72
lms1		.word text

		.byte $41
		.word dlist1
dlist2
		.byte $f0
:2		.byte $4e,<leer,>leer
clms3		.byte $d4,<cloudline,>cloudline
clms4		.byte $54,<(cloudline+64),>(cloudline+64)
		.byte $80
.rept 100
		.byte $5e
		.word logo+#*40
.endr
		.byte $f0
		.rept lines
		.byte $4e,<[vram+#*screen_width+40],>[vram+#*screen_width+40]
		.endr

		.byte $80
:2		.byte $4e,<leer,>leer

		.byte $70
		.byte $72
lms2		.word text

		.byte $41
		.word dlist2

dlisttablo .byte <dlist2,<dlist1
dlisttabhi .byte >dlist2,>dlist1

.proc dosound
;Primary POKEY:
;AUDF1: 0a  AUDC1: 01  Output: 0  (164 cycles until fire) (passive: 308 cycles)
;AUDF2: 00  AUDC2: 00  Output: 1  (24 cycles until fire) (passive: 28 cycles)
;AUDF3: 28  AUDC3: a0  Output: 1  (205 cycles until fire) (passive: 256 cycles)
;AUDF4: 00  AUDC4: a0  Output: 0  (27 cycles until fire) (passive: 47 cycles)
;AUDCTL: 28, 17-bit poly, 1.79 ch3, ch3+ch4, 64KHz
;SKCTL: 03 | recv ext | send ext | keyboard scan enabled | 
;SERIN: 2B
	lda #$0a
	sta $d200
	lda #$01
	sta $d201
	lda #$28
	sta $d204
	lda #$a0
	sta $d205
	lda #$28
	sta $d208
	rts
		
	
.endp

.proc pokey_init
	ldx #8
	lda #0
	sta $d20f ; put Pokey into Init
clear 	sta $D200,x ; clear all voices, set AUDCTL to 00
	dex
	bpl clear
	lda #3
	sta $d20f ; set skctl to normal value
	rts
.endp

scrolltab
:8	.byte 0
scrolltab2
:8	.byte >font2

shscrol	.byte 8
;softscroll routine
.proc scroller
;scroller
	ldx frame
	dec shscrol
	bpl @+ 
	jmp scroller0
@
.rept 8
;	lda charsintab+#,x
;	clc
;	adc shscrol
	lda shscrol
	tay
	lsr
	sta scrolltab+#
	lda #>font2
	sta scrolltab2+#
	tya
	and #1
	bne @+
	lda #>font
	sta scrolltab2+#
@
.endr
	rts
scroller0
;	rts
	lda #7
	sta shscrol
.rept 8
;	lda charsintab+#,x
;	clc
;	adc shscrol
	lda shscrol
	lsr
	sta scrolltab+#
	lda #>font2
	sta scrolltab2+#
.endr
	inc lms1
	inc lms2
	bne @+
	inc lms1+1
	inc lms2+1
@
	lda lms1
	cmp #<endtext
	bne @+
	lda lms1+1
	cmp #>endtext
	bne @+
	lda #<text
	sta lms1
	sta lms2
	lda #>text
	sta lms1+1
	sta lms2+1
@
	rts
.endp


.proc	NMI
	bit $d40f
	bpl VBL
	jmp dummy_dli
dliv	equ *-2

VBL
	sta regA
	stx regX
	sty regY
	inc frame
	ldx bufferflag
	lda dlisttablo,x
	sta $d402
	lda dlisttabhi,x
	sta $d403
	lda #<top_dli
	sta dliv
	lda #>top_dli
	sta dliv+1
	lda #$0c
	sta $d017
	lda #$8d
	sta $d01a
	lda #$0a
	sta $d018
	lda #$0f
	sta $d016
	lda #61
	sta $d400
	lda #0
	sta $d011
	
	lda #>cloudfont
	sta $d409
	;jsr $6240
	jsr rmtplayer+3
	jsr scroller
	jsr do_sprite_anim
	lda frame
	and #7
	bne @+
	jsr cloud_scroller2
@
	lda frame
	and #3
	bne @+
	jsr cloud_scroller
@
ter	ldx #0
	lda sintab3,x
	sta nmi.shscrol4+1
	inc ter+1

	lda $d20f		;JAC!
	and #12
	cmp #12
	bne exit
	lda $d01f
	and #7
	cmp #7
	bne exit
	lda $d010
	and $d011
	beq exit
	jmp nmi_end
exit	lda #0
	sta $d400
	sta $d40e
	lda #$ff
	sta $d301
	jmp $e474
nmi_end
	lda rega
	ldx regx
	ldy regy
	rti
top_dli
	pha
shscrol1 lda #0
	sta $d40a
	sta $d404
	lda #%10101010
	sta $d011
	lda #15
	sta $d018
	sta $d40a
	sta $d40a
	lda #$0a
	sta $d018
	lda #<top_dli2
	sta dliv
	lda #>top_dli2
	sta dliv+1
	pla
	rti
top_dli2
	pha
shscrol3 lda #0
	sta $d40a
	sta $d404
	lda #<top_dli3
	sta dliv
	lda #>top_dli3
	sta dliv+1
	pla
	rti
top_dli3
	pha
shscrol4 lda #0
	sta $d40a
	sta $d404
	lda #$7d
	sta $d016
	lda #$7a
	sta $d017
	lda #$78
	sta $d018
	lda #<dummy_dli
	sta dliv
	lda #>dummy_dli
	sta dliv+1
	pla
	rti
	
dummy_dli 
	pha
	lda #61
	sta $d400

	lda #$8d
	sta $d40a
	sta $d017
	sta $d01a
	lda #$94
	sta $d018
	lda #<dli
	sta dliv
	lda #>dli
	sta dliv+1
	pla
	rti
dli
	pha
;	txa
;	pha

	lda #$0f
	sta $d40a
	sta $d018
	sta $d40a
	sta $d40a
	lda #$04
	sta $d017
	lda #$8d
	sta $d01a
	sta $d018
	lda #0
	sta $d011

	lda scrolltab2
	sta $d40a
	sta $d409
	lda scrolltab
	sta $d404
	lda #63
	sta $d400
;vscroll ldx #15
;.rept 7
;	sta $d40a
;	lda #1
;	sta $d405
;	
;	stx $d405
;	dex
; 	;inc vscroll+9+#*13
; .endr
; 	dec vscroll+1
;	pla
;	tax
	pla
	rti
	
.endp


.proc cloud_scroller
	dec nmi.shscrol1+1
	bmi scroller0
	rts
scroller0
	lda #3
	sta nmi.shscrol1+1
	inc clms1+1
	inc clms3+1
	bne @+
	inc clms1+2
	inc clms3+2
@
	lda clms1+1
	cmp #32
	bcc @+
	lda #<cloudline
	sta clms1+1
	sta clms3+1
	lda #>(cloudline)
	sta clms1+2
	sta clms3+2
@
	rts
.endp

.proc cloud_scroller2
	dec shscrol2
	bmi scroller0
	lda shscrol2
	sta nmi.shscrol3+1
	rts
scroller0
	lda #3
	sta shscrol2
	sta nmi.shscrol3+1
	inc clms2+1
	inc clms4+1
	bne @+
	inc clms2+2
	inc clms4+2
@
	lda clms2+1
	cmp #(32+64)
	bcc @+
	lda #<(cloudline+64)
	sta clms2+1
	lda #<(cloudline+64)
	sta clms4+1
@
	rts
shscrol2 .byte 3
.endp

init:

@		lda $d40b
		bpl @-

		
		lda #0
		sei			;stop IRQ interrupts
		mva #$00 $d40e		;stop NMI interrupts	
		mva #$fe $d301		;switch off ROM to get 16k more ram
		mwa #NMI $fffa		;new NMI handler
		mwa #NMI $fffe
;shift font
		ldx #0
@
		lda font,x
		lsr
		sta font2,x
		lda font+256,x
		lsr
		sta font2+256,x
		inx
		bne @-

		lda #<dlist1
		sta $d402
		lda #>dlist1
		sta $d403
		lda #$00
		sta $d016
		lda #$0f
		sta $d01a
		lda #$8d
		sta $d017
		lda #$86
		sta $d018

		lda #0
		ldx #<music
		ldy #>music
		jsr rmtplayer	

		jsr sprite_init
;		lda #$ff
;		sta $d00d
;		sta $d00e
;		lda #$20
;		sta 53248
;		lda #$c0
;		sta 53249
;		lda #$ad
;		sta $d012
;		sta $d013
;		lda #3
;		sta 53256
;		sta 53257
;		lda #1
;		sta $d01b

		mva #$c0 $d40e		;switch on NMI+DLI again
;		cli
;generate tables
gentab		ldx #0
@
		lda #$40
		sta bitmask,x
		inx
		lda #$10
		sta bitmask,x
		inx
		lda #$04
		sta bitmask,x
		inx
		lda #$01
		sta bitmask,x
		inx
		bne @-
@		
		txa
		lsr
		lsr
		sta div4tab,x
		inx
		bne @-
		
		;jsr generate_square_tables8
		jsr mul_init
		
;test data
		lda #0
		sta camy
		sta camz
		sta camycounter
		lda #0
		sta bufferflag
		jsr cls_speedcode
		jsr cls_speedcode2
;testplot
testloop	
		lda frame
@		cmp frame
		beq @-
		ldx #0 ;camycounter
		lda camxsintab,x
		sta camx		
		ldx #0
		ldy camycounter
@
;		lda 53770
;		and #31
		lda sintab2,y
		sta nodeheight,x
		iny
		inx
		bne @-		


		lda #0
		sta frame
		sta calcflag
		lda bufferflag
		bne @+				
		jsr cls_speedcode
		jmp @+1
@		jsr cls_speedcode2
@		jsr reset_heights_speedcode

		
		lda #223
		sec
		sbc camz
		sta z1
		lda #255
		sec
		sbc camz
		sta z2
		lda #255
		sec
		sbc camz
		sta z3
?zcounter=-1
.rept 5		
		lda #-126+3*32
		clc
		adc camx
		sta x1
		lda nodeheight+#*16+16+3 ;#48
		clc
		adc camy
		sta y1
		
		lda #-126+3*32
		clc
		adc camx
		sta x2
		lda nodeheight+#*16+3 ;#48
		clc
		adc camy
		sta y2
		
		lda #-126+32+3*32
		clc
		adc camx
		sta x3
		lda nodeheight+#*16+1+3 ;#48
		clc
		adc camy
		sta y3
?zcounter = ?zcounter+1
?xcounter=3
;left side
.rept 4

		lda nodeheight+?zcounter*16+?xcounter+16 ;#48
		clc
		adc camy
		sta y1
		lda nodeheight+?zcounter*16+?xcounter ;#48
		clc
		adc camy
		sta y2
		lda nodeheight+?zcounter*16+?xcounter+1 ;#48
		clc
		adc camy
		sta y3
?xcounter=?xcounter-1	

		jsr draw_square_horizontal
		jsr draw_square_vertical
	
		lda x1
		clc
		adc #-32
		bvc @+
		lda #127
@		sta x1

		lda x2
		clc
		adc #-32
		bvc @+
		lda #127
@		sta x2
		lda x3
		clc
		adc #-32
		bvc @+
		lda #127
@		sta x3
.endr
;right
		lda #-126+4*32
		clc
		adc camx
		sta x1
		lda nodeheight+?zcounter*16+16+4 ;#48
		clc
		adc camy
		sta y1
		
		lda #-126+4*32
		clc
		adc camx
		sta x2
		lda nodeheight+?zcounter*16+4 ;#48
		clc
		adc camy
		sta y2
		
		lda #-126+32+4*32
		clc
		adc camx
		sta x3
		lda nodeheight+?zcounter*16+1+4 ;#48
		clc
		adc camy
		sta y3
		
		jsr draw_square_horizontal
		jsr draw_square_vertical

		lda #-126+5*32
		clc
		adc camx
		sta x1
		lda nodeheight+?zcounter*16+16+5 ;#48
		clc
		adc camy
		sta y1
		
		lda #-126+5*32
		clc
		adc camx
		sta x2
		lda nodeheight+?zcounter*16+5 ;#48
		clc
		adc camy
		sta y2
		
		lda #-126+32+5*32
		clc
		adc camx
		sta x3
		lda nodeheight+?zcounter*16+1+5 ;#48
		clc
		adc camy
		sta y3
		
		jsr draw_square_horizontal
		jsr draw_square_vertical

		lda #-126+6*32
		clc
		adc camx
		sta x1
		lda nodeheight+?zcounter*16+16+6 ;#48
		clc
		adc camy
		sta y1
		
		lda #-126+6*32
		clc
		adc camx
		sta x2
		lda nodeheight+?zcounter*16+6 ;#48
		clc
		adc camy
		sta y2
		
		lda #-126+32+6*32
		clc
		adc camx
		sta x3
		lda nodeheight+?zcounter*16+1+6 ;#48
		clc
		adc camy
		sta y3
		
		jsr draw_square_horizontal
		jsr draw_square_vertical

		lda #-126+7*32
		clc
		adc camx
		sta x1
		lda nodeheight+?zcounter*16+16+7 ;#48
		clc
		adc camy
		sta y1
		
		lda #-126+7*32
		clc
		adc camx
		sta x2
		lda nodeheight+?zcounter*16+7 ;#48
		clc
		adc camy
		sta y2
		
		jsr draw_square_vertical ;right edge

		lda z1
		sec
		sbc #32
;		bvc @+
;		lda #0
@		sta z1

		lda z2
		sec
		sbc #32
;		bvc @+
;		lda #0
@		sta z2

		lda z3
		sec
		sbc #32
;		bvc @+
;		lda #0
@		sta z3

.endr
;last edge
		
		
		lda #-126+3*32
		clc
		adc camx
		sta x2
		lda nodeheight+8*16+3 ;#48
		clc
		adc camy
		sta y2
		
		lda #-126+32+3*32
		clc
		adc camx
		sta x3
		lda nodeheight+8*16+1+3 ;#48
		clc
		adc camy
		sta y3
?zcounter=7
?xcounter=3
;left side
.rept 4

		lda nodeheight+?zcounter*16+?xcounter ;#48
		clc
		adc camy
		sta y2
		lda nodeheight+?zcounter*16+?xcounter+1 ;#48
		clc
		adc camy
		sta y3
?xcounter=?xcounter-1	

		jsr draw_square_horizontal
	

		lda x2
		clc
		adc #-32
		bvc @+
		lda #127
@		sta x2
		lda x3
		clc
		adc #-32
		bvc @+
		lda #127
@		sta x3
.endr
;right
		
		lda #-126+4*32
		clc
		adc camx
		sta x2
		lda nodeheight+?zcounter*16+4 ;#48
		clc
		adc camy
		sta y2
		
		lda #-126+32+4*32
		clc
		adc camx
		sta x3
		lda nodeheight+?zcounter*16+1+4 ;#48
		clc
		adc camy
		sta y3
		
		jsr draw_square_horizontal
		
		lda #-126+5*32
		clc
		adc camx
		sta x2
		lda nodeheight+?zcounter*16+5 ;#48
		clc
		adc camy
		sta y2
		
		lda #-126+32+5*32
		clc
		adc camx
		sta x3
		lda nodeheight+?zcounter*16+1+5 ;#48
		clc
		adc camy
		sta y3
		
		jsr draw_square_horizontal

		
		lda #-126+6*32
		clc
		adc camx
		sta x2
		lda nodeheight+?zcounter*16+6 ;#48
		clc
		adc camy
		sta y2
		
		lda #-126+32+6*32
		clc
		adc camx
		sta x3
		lda nodeheight+?zcounter*16+1+6 ;#48
		clc
		adc camy
		sta y3
		
		jsr draw_square_horizontal

		


		lda bufferflag
		bne @+
		jsr speedcode
		jmp @+1
@		jsr speedcode2
@
		;inc camx
		;dec camz
		inc roty
		inc camycounter
		ldx camycounter
		lda sintab,x
		sta camy
		
		lda bufferflag
		eor #1
		sta bufferflag
		lda vram_offset
		eor #40
		sta vram_offset
;		jmp *	
		jmp testloop


.proc draw_square_vertical
		
		ldx z1
		lda ztab,x
		ldx x1
		jsr fmuls ;* A*X -> A:Y (A-high byte, Y-low)
		clc
		adc #63 
		sta lx0	
		ldx z1
		lda ztab,x
		ldx y1
		jsr fmuls ;* A*X -> A:Y (A-high byte, Y-low)
		clc
		adc #23 
		sta ly0

		ldx z2
		lda ztab,x
		ldx x2
		jsr fmuls ;* A*X -> A:Y (A-high byte, Y-low)
		clc
		adc #63 
		sta lx1	
		ldx z2
		lda ztab,x
		ldx y2
		jsr fmuls ;* A*X -> A:Y (A-high byte, Y-low)
		clc
		adc #23 
		sta ly1

		;lda #32
		lda 53770
		and #31
		clc 
		adc #128
		sta st1
		;lda #32
		lda 53770
		and #31
		clc
		adc #128
		sta st2
		
		jsr do_fractal_line ;verticals
		;jsr drawto
		rts		
.endp

.proc draw_square_horizontal
		
;		ldx z2
;		lda ztab,x
;		ldx x2
;		jsr fmuls ;* A*X -> A:Y (A-high byte, Y-low)
;		clc
;		adc #63 
;		sta lx0
		ldx calcflag
		lda gridxtab,x	
		sta lx0
		lda gridxtab2,x
		sta lx1
				
		ldx z2
		lda ztab,x
		ldx y2
		jsr fmuls ;* A*X -> A:Y (A-high byte, Y-low)
		clc
		adc #23 
		sta ly0

;		ldx z3
;		lda ztab,x
;		ldx x3
;		jsr fmuls ;* A*X -> A:Y (A-high byte, Y-low)
;		clc
;		adc #63 
;		sta lx1	
;		ldx calcflag
;		sta gridxtab2,x
		
		ldx z3
		lda ztab,x
		ldx y3
		jsr fmuls ;* A*X -> A:Y (A-high byte, Y-low)
		clc
		adc #23 
		sta ly1
		
;		lda lx1
;		sec 
;		sbc lx0 ;$0f
		
		
	
		;lda #32
		lda 53770
		and #15
		clc
		adc #105
		sta st1
		;lda #32
		lda 53770
		clc
		adc #105
		and #15
		sta st2
		
		;jsr drawto
		jsr do_fractal_line ;horizontal
		inc calcflag
		rts		
.endp


.proc div8
;normal binary division
;Divides the value in $FD by the value in $FC, 8 bit integer result in $FD, 
;the first 8 fraction bits are in $FE.
; %FD/$FC = $FD,$FE

.local
        ASL $FD
        LDA #$00
        ROL

        LDX #$08
loop1
        CMP $FC
        BCC *+4
        SBC $FC
        ROL $FD
        ROL
        DEX
        BNE loop1

        LDX #$08
loop2
        CMP $FC
        BCC *+4
        SBC $FC
        ROL $FE
        ASL
        DEX
        BNE loop2
 .endl
 	rts
 .endp

fmuls ;(.byte a,x) .reg
	eor #$80
	sta l1+1
	sta h1+1
	eor #$ff
	sta l2+1
	sta h2+1
	txa
	eor #$80
	tax
	sec
l1	lda sq1l,x
l2	sbc sq2l,x
	tay
h1	lda sq1h,x
h2	sbc sq2h,x
	rts

mul_init	ldx #0
	stx sq1l+$100
	stx sq1h+$100
	stx sq2l+$ff
	stx sq2h+$ff
	ldy #$ff
msqr	txa
	lsr @
	adc sq1l+$100,x
	sta sq1l,y
	sta sq1l+$101,x
	sta sq2l-1,y
	sta sq2l+$100,x
	lda #0
	adc sq1h+$100,x
	sta sq1h,y
	sta sq1h+$101,x
	sta sq2h-1,y
	sta sq2h+$100,x
	inx
	dey
	bne msqr
	rts



linetablo
:lines	.byte <(vram+#*screen_width)
:(256-lines)	.byte <(vram+#*screen_width+(lines+1)*screen_width)
linetabhi
:lines	.byte >(vram+#*screen_width)
:(256-lines)	.byte >(vram+#*screen_width+(lines+1)*screen_width)

.proc speedcode

left	ldx #31
speedcode_loop
	lda #$55
	sta mask
.rept lines
	lda mask
	and vram+#*screen_width,x
;	beq @+
;	jmp exitfiller
@
	sta mask
	lda vram+#*screen_width,x
	eor mask
	sta vram+#*screen_width,x
.endr
exitfiller
	dex
;	cpx #1
	bpl @+
	rts
@
	jmp speedcode_loop
.endp	
	
.proc speedcode2

left	ldx #71
speedcode_loop
	lda #$55 ; 
	sta mask
.rept lines
	lda mask
	and vram+#*screen_width,x
;	bne @+
;	jmp exitfiller
@
	sta mask
	lda vram+#*screen_width,x
	eor mask
	sta vram+#*screen_width,x
.endr
exitfiller
	dex
	cpx #39
	beq @+
	jmp speedcode_loop
@
	rts
.endp	

.proc cls_speedcode
right	ldx #31
	lda #$ff
loop
.rept lines
	sta vram+#*screen_width,x
.endr
	dex
	bmi @+
	jmp loop
@	rts
.endp
.proc cls_speedcode2
right	ldx #71
	lda #$ff ;#%10101010
loop2
.rept lines
	sta vram+#*screen_width,x
.endr
	dex
	cpx #39
	beq @+
	jmp loop2
@	rts
.endp

.proc reset_heights_speedcode
	lda #128
	.rept 192
	sta ybuffer+#
	.endr
	rts
.endp

; fractal lines

;sx1 .byte 0,0,0,0,0,0,0,0,0
;sy1 .byte 0,0,0,0,0,0,0,0,0
;st1 .byte 0,0,0,0,0,0,0,0,0
;sx2 .byte 0,0,0,0,0,0,0,0,0
;sy2 .byte 0,0,0,0,0,0,0,0,0
;st2 .byte 0,0,0,0,0,0,0,0,0

.proc do_fractal_line
; check if going right (x1 <= x0)
	lda lx0
	sta sx1
	lda ly0
	sta sy1
	lda lx1
	sta sx2
	lda ly1
	sta sy2

;	ldx sx2
;	cpx sx1
;	bcs right
	
;        LDA sx2
;        sec
;        sbc sx1
;        bvc LABEL ; $80 - $10 = $70, V = 1 since -128 - 16 = -144
;        eor #$80  ; $70 eor $80 = $F0, so N = 1
;LABEL
;	bmi right
; going left, swap points	
;	ldy lx1	
;	lda lx0
;	sty lx0
;	sta lx1
;	
;	ldy ly1
;	lda ly0
;	sty ly0
;	sta ly1
;
;	ldy sx2
;	lda sx1
;	sty sx1
;	sta sx2
;
;	ldy sy2
;	lda sy1
;	sty sy1
;	sta sy2
;
;	ldy st2
;	lda st1
;	sty st1
;	sta st2
	
right
                    
                    ldx #0                  ;top = 0
                                            ;we use Xreg as top
loop_fractal_line   cpx #0
                    bpl @+                  ;if x<0 go to drawing
                    jmp exit_fractal_line
@                   lda sx2,x               ;dx = abs(sx2-sx1)
                    sec
                    sbc sx1,x
                    bcs @+
                    eor #$FF
                    adc #1
@                   cmp #2                  ;if dx<2 skip to plot point
                    bcs subdiv_fractal_line
                    ldy sx1,x
                    lda sy1,x
                    sta heights,y
                    dex
                    jmp loop_fractal_line
subdiv_fractal_line lsr                     ;ed = dx/4
                    lsr
;                    lsr
;                   lsr
;                    lsr
;                    lsr
                    sta edge_displacement
                    
                    lda sx2,x               ;sx2 = int((sx1+sx2)/2)
                    sta sx2+1,x             ;use it to copy to top+1
                    clc
                    adc sx1,x
                    lsr
                    sta sx2,x
                    sta sx1+1,x             ;copy to top+1 also
                    
                    lda sy2,x               ;sy2 = int((sy1+sy2)/2)
                    sta sy2+1,x             ;use it to copy to top+1
                    clc
                    adc sy1,x
                    lsr
                    sta sy2,x
                    
                    lda st2,x               ;st2 = st1+st2
                    sta st2+1,x             ;use it to copy to top+1
                    clc
                    adc st1,x
                    sta st2,x
                    sta st1+1,x             ;copy to top+1 also
                    
                    bvs @+                  ;if v<>0 skip displacement
                    bmi n_equal_1
                    lda sy2,x               ;n == 0
                    clc                     ;sy2 += ed
                    adc edge_displacement
                    sta sy2,x
                    jmp @+
n_equal_1           lda sy2,x               ;n == 1
                    sec                     ;sy2 -= ed
                    sbc edge_displacement
                    sta sy2,x

@                                           ;Copy new Y to top+1
                    lda sy2,x
                    sta sy1+1,x
                    
                    inx                     ;top += 1
                    jmp loop_fractal_line
exit_fractal_line


;draw pixels from x2 to x1

	ldx sx2
	cpx sx1
	bcc drawright


      ldx lx0
@
      lda heights,x ;new height
      cmp ybuffer,x ;old height
      bcs plot_skip ;new height is belower on screen than old
      sta ybuffer,x
      tay
      ;ldy heights,x ;new height
set_pixel 
      lda linetablo,y
      sta zp
      lda linetabhi,y
      sta zp+1
      txa ;get collum
      lsr
      lsr
      clc
      adc vram_offset
      tay
      lda (zp),y
      ;ora bitmask,x
      and bittab,x
      sta (zp),y
plot_skip
      inx
      cpx lx1
      bcc @-
	rts

drawright
      ldx lx1
@
      lda heights,x ;new height
      cmp ybuffer,x ;old height
      bcs plot_skipr ;new height is belower on screen than old
      sta ybuffer,x
      tay
      ;ldy heights,x ;new height
set_pixelr 
      lda linetablo,y
      sta zp
      lda linetabhi,y
      sta zp+1
      txa ;get collum
      lsr
      lsr
      clc
      adc vram_offset
      tay
      lda (zp),y
      ;ora bitmask,x
      and bittab,x
      sta (zp),y
plot_skipr
      inx
      cpx lx0
      bcc @-
	rts

      
;@      lda 53279
;qqq      cmp #6 
;      bne @-
;      lda qqq+1
;      eor #3
;      sta qqq+1
      
	rts
.endp

.proc sprite_init
	lda #0
	tax
@
	sta $a400,x
	sta $a500,x
	sta $a600,x
	sta $a700,x
	inx
	bne @-
	lda #0
	sta 52356
	sta 52357
	sta 52358
	sta 52359
	lda #$3a
	sta $d012
	sta $d014
	lda #$36
	sta $d013
	sta $d015
	lda #2
	sta 53277
	lda #$40
	sta $d004
	lda #$c0
	sta $d005
	lda #$11
	sta $d01b
	lda #$0f
	sta $d019
;	lda #61
;	sta $d400
	lda #$a0
	sta 54279
	
	lda #100
	sta sprite_ypos
	
	rts
.endp
anim_delay .byte 4
anim_frame .byte 0
.proc do_sprite_anim
	lda sprite_yposlo
	sec
	sbc #32
	sta sprite_yposlo
	lda sprite_ypos
	sbc #0
	sta sprite_ypos
	lda sprite_xposlo
	clc
	adc #128
	sta sprite_xposlo
	lda sprite_xpos
	adc #0
	sta sprite_xpos
	sta 53248
	sta 53249
	sta mask0+1
	sta mask1+1
	clc
	adc #8
	sta 53250
	sta 53251
	sta mask2+1
	sta mask3+1
	cmp #224
	bcc @+1
	lda #0
	sta sprite_xpos
	lda sprite_ypos
	tax
	clc
	adc #$19
	sta do_sprite_anim2+1
	lda #0
	
@
	sta $a400,x
	sta $a500,x
	sta $a600,x
	sta $a700,x
	inx
do_sprite_anim2 cpx #$19
	bcc @-
	lda #100
	sta sprite_ypos

@	dec anim_delay
;	beq @+
;	rts
@
	lda #4
	sta anim_delay
	inc anim_frame
	lda anim_frame
	lsr
	lsr
	cmp #$0a
	bcc @+
	lda #0
	sta anim_frame
@
copy_sprite	tax
	ldy spritestart,x
	lda sprite_ypos
	tax
	clc
	adc #$19
	sta do_sprite_anim1+1
@
	lda spritedata,y
mask0	and masktab
	sta $a400,x
	lda spritedata+256,y
mask1	and masktab
	sta $a500,x
	lda spritedata+512,y
mask2	and masktab
	sta $a600,x
	lda spritedata+768,y
mask3	and masktab
	sta $a700,x
	iny
	inx
do_sprite_anim1 cpx #$19
	bcc @-
	rts
.endp

	m_align $100
	.local bittab
.rept 32
	 .byte %00111111
	 .byte %11001111
	 .byte %11110011
	 .byte %11111100
.endr
	.endl
	m_align $100
masktab
:$3a	.byte 0
	.byte %00000001
	.byte %00000011
	.byte %00000111
	.byte %00001111
	.byte %00011111
	.byte %00111111
	.byte %01111111
:$78	.byte %11111111
	.byte %11111110
	.byte %11111100
	.byte %11111000
	.byte %11110000
	.byte %11100000
	.byte %11000000
	.byte %10000000
:$30	.byte 0


camxsintab 
:8 .byte sin(12,11,32)
  
sintab	
:4	.byte sin(0,32,64)
sintab2
:8	.byte sin(48,40,32)
sintab3
	.byte sin(8,7,256)
rotsintab
rotcostab equ rotsintab+64
	.byte sin(0,255,256)
	.byte sin(0,255,256)

	m_align $100
ztabl
;ztabh = ztabl+256
;	ins "rezitab2.prg",2
;	ins "ztab13l.dat"
ztabh
;	ins "ztab13h.dat" ;11b

ztab	
	ins "ztab8.dat"

	m_align $400
font
	ins "antic.chr"

	m_align $1000
logo
	ins "sillylogo.mic",0,100*40

;	org $7000
;	ins "msx6000.obj"
	m_align $1000
	icl "rmt_relocator.asm"

music	rmt_relocator 'feelhi6000128.rmt' *

	m_align $1000
text	
	dta d'                                                       '
	DTA d'HELLO ATARIANS ALL OVER THE "LOAD"! :) WELCOME TO THE 5TH INVITRO FOR THE 9TH EDITION OF THE BIGGEST ATARI FEST - SILLY VENTURE 2K17 IN GDANSK/POLAND, TAKING PLACE FROM '
	DTA d'8TH TO 10TH DECEMBER 2017! IN LESS THAN 2 MONTHS WE WILL MEET TOGETHER TO TALK, DRINK '
	DTA d'AND CELEBRATE MORE ANNIVERSARIES OF OUR BELOVED PLATFORMS - 45 YEARS OF ATARI, '
	DTA d'40 YEARS OF ATARI 2600 AND 25 YEARS OF THE ATARI FALCON! GET READY FOR 3 DAYS "FILLED ' 
	DTA d'TO THE BRIM" WITH ATARI STUFF! FOLLOW THE SOUND OF TIA, POKEY, YM2149, AND CRYSTAL '
	DTA d'CLEAR FALCONS SOUND (WHICHEVER YOU LIKE) AND ENTER THE HEAVENS GATE! :) GET READY '
	DTA d'FOR 2 ATARI CONCERTS: 1ST ONE BY GWEM / ASTRALWERKS^SHITKATAPULT (ROCKING THE YM2149 '
	DTA d'CHIP TO THE CORE WITH 2 ATARI STS) AND 2ND ONE BY KK/ALTAIR (SQUEEZING EVERY LAST DROP ' 
	DTA d'OF JUICE FROM THE TIA CHIP - WITH 2 ATARI 2600), DEVILS SHOW 18+ (USE YOUR IMAGINATION!), ' 
	DTA d'KEGS OF COLD POLISH BEER FOR FREE, POLISH FOOD SERVICE AND (MORE IMPORTANTLY) THE COMPETITIONS '
	DTA d'WITH UNLIMITED AMOUNT OF ENTRIES ON EACH PLATFORM! SILLY VENTURE - UNITING THE '
	DTA d'INTERNATIONAL ATARI SCENES OF VCS, XL/XE, ST/STE, TT, FALCON, LYNX & JAGUAR SINCE 2000! '
	DTA d'SPECIAL GREETINGS TO ALL DESIRE GUYS FOR MAKING THIS INVITRO POSSIBLE AND ALL '
	DTA d'RETRO KOMP/LOAD ERROR STAFF (ESP. SACHY & YOLK) FOR A OPPORTUNITY TO PRESENT IT ON THIS '
	DTA d'GREAT EVENT! LONG LIVE THE RETRO SCENE! GREY / MYSTIC BYTES SIGNING OFF... '
	DTA d'WWW.SILLYVENTURE.EU                                '
	dta d'CREDITS FOR THIS LITTLE INTRO: CODE BY HEAVEN AND POPMILO     MUSIC BY MIKER IN STEREO    LOGO BY MOONIE    CLOUDS BY VETO    PELICAN BY XANTH    '

endtext dta d'                                          '


leer
:32	.byte $ff

spritestart	.he 00 19 32 4B 64 7D 96 AF C8 E1 A1 2F 80 00 00 00
	m_align $100
spritedata
	ins "pelican.spr"
	m_align $400
cloudfont
	ins "clouds.fnt",0,384
	m_align $100
cloudline ;$8000
	dta d"   ./0123    '()*+,  '()*+,     "
	dta d"   ./0123    '()*+,  '()*+,     "
	dta d"        '()*+,       '()*+,     "
	dta d"        '()*+,       '()*+,     "
	dta d"   4567    '()*+,               "
	dta d"   4567    '()*+,               "
	
cloudend dta d"                              ",0

	m_align $100
;	org $b800
;	.ds $400

rmtplayer	= * +$400
;rmtplayer
	icl "rmtplayr128.asm"

	m_align $100
gridxtab ins "gridxtab.dat"
;.ds $80
gridxtab2 equ gridxtab+128 ;.ds $80

	opt f-
	run start