;URL:	http://xxl.atari.pl/lz4-decompressor/
;CODE:	xxl, fox
;ENTRY:	source address stored in SOURCE
;       destination adress stored in DEST
;
;	opt    h- ; nie potrzeba naglowka DOS
;	ins    'TEST.LZ4',$0b,.FILESIZE 'TEST.LZ4'-$0b-$06

	.proc unlz4
	jsr    xBIOS_GET_BYTE	; length of literals
	sta    token
:4	lsr
	beq    read_offset	   ; there is no literal
	cmp    #$0f
	jsr    getlength
literals
	jsr    xBIOS_GET_BYTE
	jsr    store
	bne    literals
read_offset
	jsr    xBIOS_GET_BYTE
	tay
	sec
	eor    #$ff
	adc    dest
	sta    src
	tya
	php
	jsr    xBIOS_GET_BYTE
	plp
	bne    not_done
	tay
	beq    unlz4_done
not_done
	eor    #$ff
	adc    dest+1
	sta    src+1
	; c=1
	lda    #$ff
token	equ    *-1
	and    #$0f
	adc    #$03	          ; 3+1=4
	cmp    #$13
	jsr    getLength

@	lda    $ffff
src	equ    *-2
	inw    src
	jsr    store
	bne    @-
	beq    unlz4	         ; zawsze
store	sta    $ffff
dest	equ    *-2
	inw    dest
	dec    lenL
	bne    unlz4_done
	dec    lenH
unlz4_done
	rts

getLength_next
	jsr    xBIOS_GET_BYTE
	tay
	clc
	adc    #$00
lenL	equ    *-1
	bcc    @+
	inc    lenH
@	iny
getLength
	sta    lenL
	beq    getLength_next
	tay
	beq    @+
	inc    lenH
@	rts
lenH	.byte  $00


xBIOS_GET_BYTE
	lda    $ffff
source	equ    *-2
	inw    source
	rts
	.endp
