
L1275	= $1275

	icl "..\..\asm\Fixes.asm"

	opt h+
	
	org $1f00

	.proc fix_mydos
;	From MDOS2.ASM
	ICHID = $340
	ICHIDZ = $20
	DOINIT = $12F5

L1275	mwa $1286+1 L1286+1

	TXA			;ELSE SAVE IOCB
	PHA
	LDY	#0
CPSICB	LDA	ICHIDZ,Y
	STA	ICHID,X		;SAVE THE 12-BYTE IOCB ENTRY
	INX
	INY
	CPY	#12
	BNE	CPSICB
	PLA
	TAX
	PHA

L1286	JSR	DOINIT		;AND CALL INIT FUNCTION

	PLA
	TAX
	PHA
	LDY	#0
CPRICB	LDA	ICHID,X		;THEN RESTORE THE 12-BYTE IOCB
	STA	ICHIDZ,Y
	INX
	INY
	CPY 	#12
	BNE	CPRICB
	PLA
	TAX
L129A	JMP $129a
	.endp

	org $2000


	icl "Misc.asm"

	.proc loader

	jsr DetectCPU
	cmp #$80
	bne invalid_cpu
	jsr DetectCPUSpeed
	lda DetectCPUSpeed.CLKM+1
	cmp #$16
	bcc invalid_cpu_speed
	cmp #$18+1
	bcs invalid_cpu_speed
	mva #$ff 580
	lda $700
	cmp #'M'
	bne no_mydos
	lda #$4c
	sta L1275
	mwa #fix_mydos.L1275 L1275+1	
no_mydos
	rts

invalid_cpu
invalid_cpu_speed
	mwa #dl 560
	jmp *

	.local dl
:11	.byte $70
	.byte $46,a(sm),$06,$06
	.byte $41,a(dl)
	.endl
	
	.local sm
	.byte "requires 65C816 cpu "
	.byte "running at 21,65 mhz"
	.byte "with 16 mb high ram "
;	.byte '0123456789012345678901234567890123456789
	.endl

	.endp


	ini loader

	opt h-
	ins "DRAGON-Original.xex"



